ALTER TABLE gr_category
       ADD  %ADD_OBRACE% CONSTRAINT fcategory_1
              FOREIGN KEY (category_task)
                             REFERENCES gr_task (task_id)  %ADD_CBRACE%;
%GO%


ALTER TABLE gr_category
       ADD  %ADD_OBRACE% CONSTRAINT fcategory_2
              FOREIGN KEY (category_workflow)
                             REFERENCES gr_workflow (workflow_id) %ADD_CBRACE%;
%GO%


ALTER TABLE gr_filter
       ADD  %ADD_OBRACE% CONSTRAINT ffilter_1
              FOREIGN KEY (filter_owner)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_filter
       ADD  %ADD_OBRACE% CONSTRAINT ffilter_2
              FOREIGN KEY (filter_task)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_filter
       ADD  %ADD_OBRACE% CONSTRAINT ffilter_3
              FOREIGN KEY (filter_type)
                             REFERENCES gr_filtertype (filtertype_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_fvalue
       ADD  %ADD_OBRACE% CONSTRAINT ffvalue_1
              FOREIGN KEY (fvalue_filter)
                             REFERENCES gr_filter (filter_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_message
       ADD  %ADD_OBRACE% CONSTRAINT fmessage_1
              FOREIGN KEY (message_resolution)
                             REFERENCES gr_resolution (resolution_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_message
       ADD  %ADD_OBRACE% CONSTRAINT fmessage_2
              FOREIGN KEY (message_handler)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_message
       ADD  %ADD_OBRACE% CONSTRAINT fmessage_3
              FOREIGN KEY (message_mstatus)
                             REFERENCES gr_mstatus (mstatus_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_message
       ADD  %ADD_OBRACE% CONSTRAINT fmessage_4
              FOREIGN KEY (message_submitter)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_message
       ADD  %ADD_OBRACE% CONSTRAINT fmessage_6
              FOREIGN KEY (message_priority)
                             REFERENCES gr_priority (priority_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_message
       ADD  %ADD_OBRACE% CONSTRAINT fmessage_7
              FOREIGN KEY (message_task)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_mprstatus
       ADD  %ADD_OBRACE% CONSTRAINT fmprstatus_1
              FOREIGN KEY (mprstatus_prstatus)
                             REFERENCES gr_prstatus (prstatus_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_mprstatus
       ADD  %ADD_OBRACE% CONSTRAINT fmprstatus_2
              FOREIGN KEY (mprstatus_mstatus)
                             REFERENCES gr_mstatus (mstatus_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_mstatus
       ADD  %ADD_OBRACE% CONSTRAINT fmstatus_1
              FOREIGN KEY (mstatus_workflow)
                             REFERENCES gr_workflow (workflow_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_prstatus
       ADD  %ADD_OBRACE% CONSTRAINT fprstatus_1
              FOREIGN KEY (prstatus_user)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%



ALTER TABLE gr_report
       ADD  %ADD_OBRACE% CONSTRAINT freport_1
              FOREIGN KEY (report_owner)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_report
       ADD  %ADD_OBRACE% CONSTRAINT freport_2
              FOREIGN KEY (report_task)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_report
       ADD  %ADD_OBRACE% CONSTRAINT freport_3
              FOREIGN KEY (report_filter)
                             REFERENCES gr_filter (filter_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_report
       ADD  %ADD_OBRACE% CONSTRAINT freport_4
              FOREIGN KEY (report_rtype)
                             REFERENCES gr_rtype (rtype_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_resolution
       ADD  %ADD_OBRACE% CONSTRAINT fresolution_1
              FOREIGN KEY (resolution_mstatus)
                             REFERENCES gr_mstatus (mstatus_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_rolestatus
       ADD  %ADD_OBRACE% CONSTRAINT frolestatus_2
              FOREIGN KEY (rolestatus_prstatus)
                             REFERENCES gr_prstatus (prstatus_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_status
       ADD  %ADD_OBRACE% CONSTRAINT fstatus_1
              FOREIGN KEY (status_workflow)
                             REFERENCES gr_workflow (workflow_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_subscriber
       ADD  %ADD_OBRACE% CONSTRAINT fsubscriber_1
              FOREIGN KEY (subscriber_task)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_subscriber
       ADD  %ADD_OBRACE% CONSTRAINT fsubscriber_2
              FOREIGN KEY (subscriber_filter)
                             REFERENCES gr_filter (filter_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_subscriber
       ADD  %ADD_OBRACE% CONSTRAINT fsubscriber_3
              FOREIGN KEY (subscriber_user)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_task
       ADD  %ADD_OBRACE% CONSTRAINT ftask_1
              FOREIGN KEY (task_submitter)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_task
       ADD  %ADD_OBRACE% CONSTRAINT ftask_2
              FOREIGN KEY (task_handler)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_task
       ADD  %ADD_OBRACE% CONSTRAINT ftask_3
              FOREIGN KEY (task_resolution)
                             REFERENCES gr_resolution (resolution_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_task
       ADD  %ADD_OBRACE% CONSTRAINT ftask_4
              FOREIGN KEY (task_status)
                             REFERENCES gr_status (status_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_task
       ADD  %ADD_OBRACE% CONSTRAINT ftask_5
              FOREIGN KEY (task_category)
                             REFERENCES gr_category (category_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_task
       ADD  %ADD_OBRACE% CONSTRAINT ftask_6
              FOREIGN KEY (task_parent)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_task
       ADD  %ADD_OBRACE% CONSTRAINT ftask_7
              FOREIGN KEY (task_priority)
                             REFERENCES gr_priority (priority_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_transition
       ADD  %ADD_OBRACE% CONSTRAINT ftransition_1
              FOREIGN KEY (transition_mstatus)
                             REFERENCES gr_mstatus (mstatus_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_transition
       ADD  %ADD_OBRACE% CONSTRAINT ftransition_3
              FOREIGN KEY (transition_finish)
                             REFERENCES gr_status (status_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_transition
       ADD  %ADD_OBRACE% CONSTRAINT ftransition_4
              FOREIGN KEY (transition_start)
                             REFERENCES gr_status (status_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_udf
       ADD  %ADD_OBRACE% CONSTRAINT fudf_1
              FOREIGN KEY (udf_udfsource)
                             REFERENCES gr_udfsource (udfsource_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_udf
       ADD  %ADD_OBRACE% CONSTRAINT fudf_2
              FOREIGN KEY (udf_script)
                             REFERENCES gr_script (script_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_udflist
       ADD  %ADD_OBRACE% CONSTRAINT fudflist_1
              FOREIGN KEY (udflist_udf)
                             REFERENCES gr_udf (udf_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_udfsource
       ADD  %ADD_OBRACE% CONSTRAINT fudfsource_1
              FOREIGN KEY (udfsource_user)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_udfsource
       ADD  %ADD_OBRACE% CONSTRAINT fudfsource_2
              FOREIGN KEY (udfsource_task)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_udfsource
       ADD  %ADD_OBRACE% CONSTRAINT fudfsource_3
              FOREIGN KEY (udfsource_workflow)
                             REFERENCES gr_workflow (workflow_id) %ADD_CBRACE% ;
%GO%



ALTER TABLE gr_udfval
       ADD  %ADD_OBRACE% CONSTRAINT fudfval_1
              FOREIGN KEY (udfval_udflist)
                             REFERENCES gr_udflist (udflist_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_udfval
       ADD  %ADD_OBRACE% CONSTRAINT fudfval_2
              FOREIGN KEY (udfval_udfsource)
                             REFERENCES gr_udfsource (udfsource_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_udfval
       ADD  %ADD_OBRACE% CONSTRAINT fudfval_3
              FOREIGN KEY (udfval_udf)
                             REFERENCES gr_udf (udf_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_user
       ADD  %ADD_OBRACE% CONSTRAINT fuser_1
              FOREIGN KEY (user_prstatus)
                             REFERENCES gr_prstatus (prstatus_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_user
       ADD  %ADD_OBRACE% CONSTRAINT fuser_2
              FOREIGN KEY (user_manager)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_user
       ADD  %ADD_OBRACE% CONSTRAINT fuser_3
              FOREIGN KEY (user_emailtype)
                             REFERENCES gr_emailtype (emailtype_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_user
       ADD  %ADD_OBRACE% CONSTRAINT fuser_4
              FOREIGN KEY (user_default_project)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_workflow
       ADD  %ADD_OBRACE% CONSTRAINT fworkflow_1
              FOREIGN KEY (workflow_task)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_priority
       ADD  %ADD_OBRACE% CONSTRAINT fpriority_1
              FOREIGN KEY (priority_workflow)
                             REFERENCES gr_workflow (workflow_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_catrelation
       ADD  %ADD_OBRACE% CONSTRAINT fcatrelation_1
              FOREIGN KEY (catrelation_category)
                             REFERENCES gr_category (category_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_catrelation
       ADD  %ADD_OBRACE% CONSTRAINT fcatrelation_2
              FOREIGN KEY (catrelation_child)
                             REFERENCES gr_category (category_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_cprstatus
       ADD  %ADD_OBRACE% CONSTRAINT fcprstatus_1
              FOREIGN KEY (cprstatus_category)
                             REFERENCES gr_category (category_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_cprstatus
       ADD  %ADD_OBRACE% CONSTRAINT fcprstatus_2
              FOREIGN KEY (cprstatus_prstatus)
                             REFERENCES gr_prstatus (prstatus_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_notification
       ADD  %ADD_OBRACE% CONSTRAINT fnotification_1
              FOREIGN KEY (notification_task)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_notification
       ADD  %ADD_OBRACE% CONSTRAINT fnotification_2
              FOREIGN KEY (notification_filter)
                             REFERENCES gr_filter (filter_id) %ADD_CBRACE% ;
%GO%


ALTER TABLE gr_notification
       ADD  %ADD_OBRACE% CONSTRAINT fnotification_3
              FOREIGN KEY (notification_user)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_mailimport
       ADD  %ADD_OBRACE% CONSTRAINT fmailimport_2
              FOREIGN KEY (mailimport_category)
                             REFERENCES gr_category (category_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_mailimport
       ADD  %ADD_OBRACE% CONSTRAINT fmailimport_4
              FOREIGN KEY (mailimport_task)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_task
       ADD  %ADD_OBRACE% CONSTRAINT ftask_8
              FOREIGN KEY (task_longtext)
                             REFERENCES gr_longtext (longtext_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_message
       ADD  %ADD_OBRACE% CONSTRAINT fmessage_5
              FOREIGN KEY (message_longtext)
                             REFERENCES gr_longtext (longtext_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_longtext
       ADD  %ADD_OBRACE% CONSTRAINT flongtext_1
              FOREIGN KEY (longtext_reference)
                             REFERENCES gr_longtext (longtext_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_emailtype
       ADD  %ADD_OBRACE% CONSTRAINT femailtype_1
              FOREIGN KEY (emailtype_template)
                             REFERENCES gr_longtext (longtext_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_emailtype
       ADD  %ADD_OBRACE% CONSTRAINT femailtype_2
              FOREIGN KEY (emailtype_user)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_emailtype
       ADD  %ADD_OBRACE% CONSTRAINT femailtype_3
              FOREIGN KEY (emailtype_contenttype)
                             REFERENCES gr_contenttype (contenttype_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_acl
       ADD  %ADD_OBRACE% CONSTRAINT facl_1
              FOREIGN KEY (acl_user)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_acl
       ADD  %ADD_OBRACE% CONSTRAINT facl_2
              FOREIGN KEY (acl_task)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_acl
       ADD  %ADD_OBRACE% CONSTRAINT facl_3
              FOREIGN KEY (acl_prstatus)
                             REFERENCES gr_prstatus (prstatus_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_acl
       ADD  %ADD_OBRACE% CONSTRAINT facl_4
              FOREIGN KEY (acl_owner)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_currentfilter
       ADD  %ADD_OBRACE% CONSTRAINT fcurrentfilter_1
              FOREIGN KEY (currentfilter_user)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_currentfilter
       ADD  %ADD_OBRACE% CONSTRAINT fcurrentfilter_2
              FOREIGN KEY (currentfilter_task)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_currentfilter
       ADD  %ADD_OBRACE% CONSTRAINT fcurrentfilter_3
              FOREIGN KEY (currentfilter_fil)
                             REFERENCES gr_filter (filter_id) %ADD_CBRACE% ;
%GO%
ALTER TABLE gr_registration
       ADD  %ADD_OBRACE% CONSTRAINT fregistration_1
              FOREIGN KEY (registration_user)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_registration
       ADD  %ADD_OBRACE% CONSTRAINT fregistration_2
              FOREIGN KEY (registration_prstatus)
                             REFERENCES gr_prstatus (prstatus_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_registration
       ADD  %ADD_OBRACE% CONSTRAINT fregistration_3
              FOREIGN KEY (registration_task)
                             REFERENCES gr_task (task_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_registration
       ADD  %ADD_OBRACE% CONSTRAINT fregistration_4
              FOREIGN KEY (registration_category)
                             REFERENCES gr_category (category_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_prstatus
       ADD  %ADD_OBRACE% CONSTRAINT fprstatus_2
              FOREIGN KEY (prstatus_parent)
                             REFERENCES gr_prstatus (prstatus_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_script
       ADD  %ADD_OBRACE% CONSTRAINT fscript_1
              FOREIGN KEY (script_type)
                             REFERENCES gr_scripttype (scripttype_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_script
       ADD  %ADD_OBRACE% CONSTRAINT fscript_2
              FOREIGN KEY (script_owner)
                             REFERENCES gr_user (user_id) %ADD_CBRACE% ;
%GO%

ALTER TABLE gr_script
       ADD  %ADD_OBRACE% CONSTRAINT fscript_3
              FOREIGN KEY (script_longtext)
                             REFERENCES gr_longtext (longtext_id) %ADD_CBRACE% ;
%GO%