calDateFormat    = "DD/MM/YY";


// CALENDAR COLORS
topBackground    = "white";         // BG COLOR OF THE TOP FRAME
bottomBackground = "white";         // BG COLOR OF THE BOTTOM FRAME
tableBGColor     = "#0047BE";         // BG COLOR OF THE BOTTOM FRAME'S TABLE
cellColor        = "#F0F0F0";     // TABLE CELL BG COLOR OF THE DATE CELLS IN THE BOTTOM FRAME
headingCellColor = "#547ED9";         // TABLE CELL BG COLOR OF THE WEEKDAY ABBREVIATIONS
headingTextColor = "#FFFFFF";         // TEXT COLOR OF THE WEEKDAY ABBREVIATIONS
dateColor        = "#0047BE";          // TEXT COLOR OF THE LISTED DATES (1-28+)
focusColor       = "#ff0000";       // TEXT COLOR OF THE SELECTED DATE (OR CURRENT DATE)
hoverColor       = "#000000";       // TEXT COLOR OF A LINK WHEN YOU HOVER OVER IT
fontStyle        = "12px Tahoma, arial";           // TEXT STYLE FOR DATES
headingFontStyle = "bold 12px Tahoma, arial";      // TEXT STYLE FOR WEEKDAY ABBREVIATIONS
sundayColor = "#B1C5EA";
// FORMATTING PREFERENCES
bottomBorder  = false;        // TRUE/FALSE (WHETHER TO DISPLAY BOTTOM CALENDAR BORDER)
tableBorder   = 0;            // SIZE OF CALENDAR TABLE BORDER (BOTTOM FRAME) 0=none



// DETERMINE BROWSER BRAND
var isNav = false;
var isIE  = false;

// ASSUME IT'S EITHER NETSCAPE OR MSIE
if (document.all)
    isIE = true;
else
    isNav = true;

// GET CURRENTLY SELECTED LANGUAGE
if (isNav)
    selectedLanguage = navigator.language;
else
    selectedLanguage = navigator.browserLanguage;


// PRE-BUILD PORTIONS OF THE CALENDAR WHEN THIS JS LIBRARY LOADS INTO THE BROWSER
buildCalParts();


function setDateField(dateField, pattern) { // entry point
    calDateFormat = pattern;
    calDateField = dateField;
    inDate = dateField.value;
    setInitialDate(inDate, pattern);
    calDocTop    = buildTopCalFrame();
    //calDocBottom = buildBottomCalFrame();
}


function setInitialDate(inDate, pattern) {
    calDate = toDate(inDate, pattern);
    if (calDate == null) {
        calDate = new Date();
    }
    calDay  = calDate.getDate();
    calDate.setDate(1);
}


function showCalendar(dateField) {
    setDateField(dateField);
    calDocFrameset = 
        "<HTML><HEAD><TITLE>JavaScript Calendar</TITLE></HEAD>\n" +
        "<FRAMESET ROWS='70,*' FRAMEBORDER='0'>\n" +
        "  <FRAME NAME='topCalFrame' SRC='javascript:parent.opener.calDocTop' SCROLLING='no'>\n" +
        "  <FRAME NAME='bottomCalFrame' SRC='javascript:parent.opener.calDocBottom' SCROLLING='no'>\n" +
        "</FRAMESET>\n";
    top.newWin = window.open("javascript:parent.opener.calDocFrameset", "calWin", winPrefs);
    top.newWin.focus();
}


function buildTopCalFrame() {

    var calDoc =
        "<HTML>" +
        "<HEAD>" +
        "</HEAD>" +
        "<BODY BGCOLOR='" + topBackground + "'>" +
        "<FORM NAME='calControl' onSubmit='return false;'>" +
        "<CENTER>" +
        "<TABLE CELLPADDING=0 CELLSPACING=1 BORDER=0>" +
        "<TR><TD COLSPAN=7>" +
        "<CENTER>" +
        getMonthSelect() +
        "<INPUT NAME='year' VALUE='" + calDate.getFullYear() + "' TYPE=TEXT SIZE=4 MAXLENGTH=4 onChange='parent.opener.setYear()'>" +
        "</CENTER>" +
        "</TD>" +
        "</TR>" +
        "<TR>" +
        "<TD COLSPAN=7>" +
        "<INPUT " +
        "TYPE=BUTTON NAME='previousYear' VALUE='<<'    onClick='parent.opener.setPreviousYear()'><INPUT " +
        "TYPE=BUTTON NAME='previousMonth' VALUE=' < '   onClick='parent.opener.setPreviousMonth()'><INPUT " +
        "TYPE=BUTTON NAME='today' VALUE='Today' onClick='parent.opener.setToday()'><INPUT " +
        "TYPE=BUTTON NAME='nextMonth' VALUE=' > '   onClick='parent.opener.setNextMonth()'><INPUT " +
        "TYPE=BUTTON NAME='nextYear' VALUE='>>'    onClick='parent.opener.setNextYear()'>" +
        "</TD>" +
        "</TR>" +
        "</TABLE>" +
        "</CENTER>" +
        "</FORM>" +
        "</BODY>" +
        "</HTML>";

    return calDoc;
}


function buildBottomCalFrame() {       

    var calDoc = calendarBegin;

    month   = calDate.getMonth();
    year    = calDate.getFullYear();
    day     = calDay;

    var i   = 0;

    var days = getDaysInMonth();

    if (day > days) {
        day = days;
    }

    var firstOfMonth = new Date (year, month, 1);

    var startingPos  = firstOfMonth.getDay();
    days += startingPos;

    var columnCount = 0;

    for (i = 0; i < startingPos; i++) {

        calDoc += blankCell;
        columnCount++;
    }

    var currentDay = 0;
    var dayType    = "weekday";

    for (i = startingPos; i < days; i++) {

        var paddingChar = "&nbsp;";

        if (i-startingPos+1 < 10) {
            padding = "&nbsp;&nbsp;";
        }
        else {
            padding = "&nbsp;";
        }

        currentDay = i-startingPos+1;

        if (currentDay == day) {
            dayType = "focusDay";
        }
        else if (columnCount % 7 == 0)
        {
                        dayType="sunday";
        }
                else {
            dayType = "weekDay";
        }


        calDoc += "<TD class='"+dayType +"' align=center bgcolor='" + cellColor + "'>" +
                  "<a href='javascript:parent.opener.returnDate(" + 
                  currentDay + ")'>" + padding + currentDay + paddingChar + "</a></TD>";

        columnCount++;

        if (columnCount % 7 == 0) {
            calDoc += "</TR><TR>";
        }
    }

    for (i=days; i<42; i++)  {

        calDoc += blankCell;
        columnCount++;

        if (columnCount % 7 == 0) {
            calDoc += "</TR>";
            if (i<41) {
                calDoc += "<TR>";
            }
        }
    }

    calDoc += calendarEnd;

    return calDoc;
}


function writeCalendar() {
    calDocBottom = buildBottomCalFrame();
    top.newWin.frames['bottomCalFrame'].document.open();
    top.newWin.frames['bottomCalFrame'].document.write(calDocBottom);
    top.newWin.frames['bottomCalFrame'].document.close();
}



function setToday() {
    calDate = new Date();
    calDay  = calDate.getDate();
    var month = calDate.getMonth();
    var year  = calDate.getFullYear();
    top.newWin.frames['topCalFrame'].document.calControl.month.selectedIndex = month;
    top.newWin.frames['topCalFrame'].document.calControl.year.value = year;
    writeCalendar();
}


function setYear() {

    var year  = top.newWin.frames['topCalFrame'].document.calControl.year.value;
    if (isFourDigitYear(year)) {
        calDate.setFullYear(year);
        writeCalendar();
    }
    else {
        top.newWin.frames['topCalFrame'].document.calControl.year.focus();
        top.newWin.frames['topCalFrame'].document.calControl.year.select();
    }
}


function setCurrentMonth() {

    var month = top.newWin.frames['topCalFrame'].document.calControl.month.selectedIndex;

    calDate.setMonth(month);
    writeCalendar();
}


function setPreviousYear() {

    var year  = top.newWin.frames['topCalFrame'].document.calControl.year.value;

    if (isFourDigitYear(year) && year > 1000) {
        year--;
        calDate.setFullYear(year);
        top.newWin.frames['topCalFrame'].document.calControl.year.value = year;
        writeCalendar();
    }
}


function setPreviousMonth() {

    var year  = top.newWin.frames['topCalFrame'].document.calControl.year.value;
    if (isFourDigitYear(year)) {
        var month = top.newWin.frames['topCalFrame'].document.calControl.month.selectedIndex;

        if (month == 0) {
            month = 11;
            if (year > 1000) {
                year--;
                calDate.setFullYear(year);
                top.newWin.frames['topCalFrame'].document.calControl.year.value = year;
            }
        }
        else {
            month--;
        }
        calDate.setMonth(month);
        top.newWin.frames['topCalFrame'].document.calControl.month.selectedIndex = month;
        writeCalendar();
    }
}


function setNextMonth() {

    var year = top.newWin.frames['topCalFrame'].document.calControl.year.value;

    if (isFourDigitYear(year)) {
        var month = top.newWin.frames['topCalFrame'].document.calControl.month.selectedIndex;

        if (month == 11) {
            month = 0;
            year++;
            calDate.setFullYear(year);
            top.newWin.frames['topCalFrame'].document.calControl.year.value = year;
        }
        else {
            month++;
        }
        calDate.setMonth(month);
        top.newWin.frames['topCalFrame'].document.calControl.month.selectedIndex = month;
        writeCalendar();
    }
}


function setNextYear() {

    var year  = top.newWin.frames['topCalFrame'].document.calControl.year.value;
    if (isFourDigitYear(year)) {
        year++;
        calDate.setFullYear(year);
        top.newWin.frames['topCalFrame'].document.calControl.year.value = year;
        writeCalendar();
    }
}


// GET NUMBER OF DAYS IN MONTH
function getDaysInMonth()  {

    var days;
    var month = calDate.getMonth()+1;
    var year  = calDate.getFullYear();

    // RETURN 31 DAYS
    if (month==1 || month==3 || month==5 || month==7 || month==8 ||
        month==10 || month==12)  {
        days=31;
    }
    // RETURN 30 DAYS
    else if (month==4 || month==6 || month==9 || month==11) {
        days=30;
    }
    // RETURN 29 DAYS
    else if (month==2)  {
        if (isLeapYear(year)) {
            days=29;
        }
        // RETURN 28 DAYS
        else {
            days=28;
        }
    }
    return (days);
}


// CHECK TO SEE IF YEAR IS A LEAP YEAR
function isLeapYear (Year) {

    if (((Year % 4)==0) && ((Year % 100)!=0) || ((Year % 400)==0)) {
        return (true);
    }
    else {
        return (false);
    }
}


// ENSURE THAT THE YEAR IS FOUR DIGITS IN LENGTH
function isFourDigitYear(year) {

    if (year.length != 4) {
        top.newWin.frames['topCalFrame'].document.calControl.year.value = calDate.getFullYear();
        top.newWin.frames['topCalFrame'].document.calControl.year.select();
        top.newWin.frames['topCalFrame'].document.calControl.year.focus();
    }
    else {
        return true;
    }
}


// BUILD THE MONTH SELECT LIST
function getMonthSelect() {

        monthArray = new Array('January', 'February', 'March', 'April', 'May', 'June',
                               'July', 'August', 'September', 'October', 'November', 'December');

    // DETERMINE MONTH TO SET AS DEFAULT
    var activeMonth = calDate.getMonth();

    // START HTML SELECT LIST ELEMENT
    monthSelect = "<SELECT NAME='month' onChange='parent.opener.setCurrentMonth()'>";

    // LOOP THROUGH MONTH ARRAY
    for (i in monthArray) {
        
        // SHOW THE CORRECT MONTH IN THE SELECT LIST
        if (i == activeMonth) {
            monthSelect += "<OPTION SELECTED>" + monthArray[i] + "\n";
        }
        else {
            monthSelect += "<OPTION>" + monthArray[i] + "\n";
        }
    }
    monthSelect += "</SELECT>";

    // RETURN A STRING VALUE WHICH CONTAINS A SELECT LIST OF ALL 12 MONTHS
    return monthSelect;
}


// SET DAYS OF THE WEEK DEPENDING ON LANGUAGE
function createWeekdayList() {

        weekdayList  = new Array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
        weekdayArray = new Array('Su','Mo','Tu','We','Th','Fr','Sa');

    // START HTML TO HOLD WEEKDAY NAMES IN TABLE FORMAT
    var weekdays = "<TR BGCOLOR='" + headingCellColor + "'>";

    // LOOP THROUGH WEEKDAY ARRAY
    for (i in weekdayArray) {

        weekdays += "<TD class='heading' align=center>" + weekdayArray[i] + "</TD>";
    }
    weekdays += "</TR>";

    // RETURN TABLE ROW OF WEEKDAY ABBREVIATIONS TO DISPLAY ABOVE THE CALENDAR
    return weekdays;
}


// PRE-BUILD PORTIONS OF THE CALENDAR (FOR PERFORMANCE REASONS)
function buildCalParts() {

    // GENERATE WEEKDAY HEADERS FOR THE CALENDAR
    weekdays = createWeekdayList();

    // BUILD THE BLANK CELL ROWS
    blankCell = "<TD align=center bgcolor='" + cellColor + "'>&nbsp;&nbsp;&nbsp;</TD>";

    // BUILD THE TOP PORTION OF THE CALENDAR PAGE USING CSS TO CONTROL SOME DISPLAY ELEMENTS
    calendarBegin =
        "<HTML>" +
        "<HEAD>" +
        // STYLESHEET DEFINES APPEARANCE OF CALENDAR
        "<STYLE type='text/css'>" +
        "<!--" +
        "TD.heading { text-decoration: none; color:" + headingTextColor + "; font: " + headingFontStyle + "; }" +
        ".focusDay A:link { color: " + focusColor + "; text-decoration: none; font: " + fontStyle + "; }" +
        ".focusDay A:hover { color: " + focusColor + "; text-decoration: none; font: " + fontStyle + "; }" +
        ".focusDay A:visited { color: " + focusColor + "; text-decoration: none; font: " + fontStyle + "; }" +
        ".weekday A:link { color: " + dateColor + "; text-decoration: none; font: " + fontStyle + "; }" +
        ".weekday A:hover { color: " + hoverColor + "; font: " + fontStyle + "; }" +
                ".weekday A:visited { color: " + dateColor + "; text-decoration: none; font: " + fontStyle + "; }" +
        ".sunday A:link { color: " + dateColor + "; text-decoration: none; font: " + fontStyle + "; }" +
        ".sunday A:hover { color: " + hoverColor + "; font: " + fontStyle + "; }" +
                ".sunday A:visited { color: " + dateColor + "; text-decoration: none; font: " + fontStyle + "; }" +
                "TD.sunday  { background-color: " + sundayColor + "; }" +
                "-->" +
        "</STYLE>" +
        "</HEAD>" +
        "<BODY BGCOLOR='" + bottomBackground + "'" +
        "<CENTER>";

        // NAVIGATOR NEEDS A TABLE CONTAINER TO DISPLAY THE TABLE OUTLINES PROPERLY
        if (isNav) {
            calendarBegin += 
                "<TABLE CELLPADDING=0 CELLSPACING=1 BORDER=" + tableBorder + " ALIGN=CENTER BGCOLOR='" + tableBGColor + "'><TR><TD>";
        }

        // BUILD WEEKDAY HEADINGS
        calendarBegin +=
            "<TABLE CELLPADDING=0 CELLSPACING=1 BORDER=" + tableBorder + " ALIGN=CENTER BGCOLOR='" + tableBGColor + "'>" +
            weekdays +
            "<TR>";


    // BUILD THE BOTTOM PORTION OF THE CALENDAR PAGE
    calendarEnd = "";

        // WHETHER OR NOT TO DISPLAY A THICK LINE BELOW THE CALENDAR
        if (bottomBorder) {
            calendarEnd += "<TR></TR>";
        }

        // NAVIGATOR NEEDS A TABLE CONTAINER TO DISPLAY THE BORDERS PROPERLY
        if (isNav) {
            calendarEnd += "</TD></TR></TABLE>";
        }

        // END THE TABLE AND HTML DOCUMENT
        calendarEnd +=
            "</TABLE>" +
            "</CENTER>"+
            "</BODY>" +
            "</HTML>";
}


// REPLACE ALL INSTANCES OF find WITH replace
// inString: the string you want to convert
// find:     the value to search for
// replace:  the value to substitute
//
// usage:    jsReplace(inString, find, replace);
// example:  jsReplace("To be or not to be", "be", "ski");
//           result: "To ski or not to ski"
//
function jsReplace(inString, find, replace) {

    var outString = "";

    if (!inString) {
        return "";
    }

    // REPLACE ALL INSTANCES OF find WITH replace
    if (inString.indexOf(find) != -1) {
        // SEPARATE THE STRING INTO AN ARRAY OF STRINGS USING THE VALUE IN find
        t = inString.split(find);

        // JOIN ALL ELEMENTS OF THE ARRAY, SEPARATED BY THE VALUE IN replace
        return (t.join(replace));
    }
    else {
        return inString;
    }
}


// SET FIELD VALUE TO THE DATE SELECTED AND CLOSE THE CALENDAR WINDOW
function returnDate(inDay) {
    // inDay = THE DAY THE USER CLICKED ON
    calDate.setDate(inDay);

    // SET THE DATE RETURNED TO THE USER
    var day           = calDate.getDate();
    var month         = calDate.getMonth()+1;
    var year          = calDate.getFullYear();
    var monthString   = monthArray[calDate.getMonth()];
    var monthAbbrev   = monthString.substring(0,3);
    var weekday       = weekdayList[calDate.getDay()];
    var weekdayAbbrev = weekday.substring(0,3);
        outDate = calDateFormat;
            re=/d+/g;
                outDate = outDate.replace(re,day);
                re=/y+/g;
                outDate = outDate.replace(re,year);
                re=/M+/g;
                outDate = outDate.replace(re,month);
                re=/h+/g;
                outDate = outDate.replace(re,"12");
                re=/H+/g;
                outDate = outDate.replace(re,"00");
                re=/m+/g;
                outDate = outDate.replace(re,"00");
                re=/a/g;
                outDate = outDate.replace(re,"AM");
    
    // SET THE VALUE OF THE FIELD THAT WAS PASSED TO THE CALENDAR
    calDateField.value = outDate;

    // GIVE FOCUS BACK TO THE DATE FIELD
    if(calDateField.disabled == false)
        calDateField.focus();

    // CLOSE THE CALENDAR WINDOW
    top.newWin.close()
}

// date validation block begin
function getRegExp(pattern) {
    var r, re;
    re=/([\.\,\:\\\/\>\<\-\+])/gi;
    pattern = pattern.replace(re,"\\$1");
    re=/a/gi;
    pattern = pattern.replace(re,"?");
    re=/[\w]/gi;
    pattern = pattern.replace(re,"(\\d+)");
    re=/\(\\d\+\)\(\\d\+\)/gi;
    pattern = pattern.replace(re,"(\\d+)");
    re=/\(\\d\+\)\(\\d\+\)/gi;
    pattern = pattern.replace(re,"(\\d+)");
    re=/\?/gi;
    pattern = pattern.replace(re,"\\wM");
    re=/\s/gi;
    pattern = pattern.replace(re,"\\s");
    return new RegExp("^"+pattern+"$","gi");
}

function getRegExpShort(pattern){
    var r, re;
    re=/\S+y\S/gi;
    var t = pattern.match(re);
    pattern=t[0];
    return getRegExp(pattern);
}

function toDate(st, fpattern){
    pattern = fpattern;
    if (pattern.length > 0) {
        var re2 =getRegExpShort(pattern);
        re = getRegExp(pattern);
        if (st.search(re) ==-1 && st.search(re2)==-1) {
            return null;
        } else {
            var year, month, day, hour, minute;
            var yearP, monthP, dayP, hour1P, minuteP, hour2P, hourP;
            var pt = fpattern;
            yearP= pt.indexOf("y");
            monthP = pt.indexOf("M");
            dayP = pt.indexOf("d");
            hour1P = pt.indexOf("H"); // 24 hours position
            hour2P = pt.indexOf("h"); // 12 hours position
            if (hour1P>hour2P) {
                hourP=hour1P;
            } else {
                hourP = hour2P;
            };
            if (hourP==-1) {
                hourP=1000;
            };

            minuteP = pt.indexOf("m");
            if (minuteP ==-1) {
                minuteP=1002;
            };
            var d;
            var datestamp= new Array(RegExp.$1,RegExp.$2,RegExp.$3,RegExp.$4,RegExp.$5)
            if (dayP>monthP){
                d = datestamp[1];
                datestamp[1]=datestamp[0];
                datestamp[0]=d;
            };
            if (dayP>yearP){
                d = datestamp[2];
                datestamp[2]=datestamp[0];
                datestamp[0]=d;
            };
            if (dayP>hourP){
                d = datestamp[3];
                datestamp[3]=datestamp[0];
                datestamp[0]=d;
            };
            if (dayP>minuteP){
                d = datestamp[4];
                datestamp[4]=datestamp[0];
                datestamp[0]=d;
            };
            if (monthP>yearP){
                d = datestamp[2];
                datestamp[2]=datestamp[1];
                datestamp[1]=d;
            };
            if (monthP>hourP){
                d = datestamp[3];
                datestamp[3]=datestamp[1];
                datestamp[1]=d;
            };
            if (monthP>minuteP){
                d = datestamp[4];
                datestamp[4]=datestamp[1];
                datestamp[1]=d;
            };
            if (yearP>hourP){
                d = datestamp[3];
                datestamp[3]=datestamp[2];
                datestamp[2]=d;
            };
            if (yearP>minuteP){
                d = datestamp[4];
                datestamp[4]=datestamp[2];
                datestamp[2]=d;
            };
            if (hourP>minuteP){
                d = datestamp[4];
                datestamp[4]=datestamp[3];
                datestamp[3]=d;
            };

            day = parseInt(datestamp[0], 10);
            month = parseInt(datestamp[1], 10) - 1;
            year = parseInt(datestamp[2], 10);
            if (year < 70)
                year += 2000;
            else if (year < 100)
                year += 1900;
            hour = parseInt(datestamp[3], 10);
            minute = parseInt(datestamp[4], 10);
            calDate = new Date(year,month,day,hour,minute, 0);
            if (isNaN(calDate)) {
                return null;
            } else {
                var myday = calDate.getDate();
                var mymonth = calDate.getMonth();
                var myyear = calDate.getFullYear();
                mds = myyear.toString();
                var myyears = mds.substr(2);
                if (myday != day || mymonth != month || (myyear != year  && myyears != year)) {
                    return null;
                }
            }
            if (hour1P<hour2P) {
                if (hour>12 || hour < 1) {
                    return null;
                };
            } else if (hour1P>hour2P) {
                if (hour>23 || hour < 0) {
                    return null;
                };
            };
        };
    };
    return calDate;
}
// date validation block end
