// for autoselect listboxes
function selectColumn(sender, selectIndex, columnIndex){
    var trs = sender.parentNode.parentNode.parentNode.getElementsByTagName("tr");
    for (var i = 1; i < trs.length; i++){
        var s = trs[i].getElementsByTagName("td")[columnIndex];
        if (s)
            s = s.getElementsByTagName("select")[0];
        if (s && !s.disabled)
            s.selectedIndex = selectIndex;
    }
    sender.selectedIndex = 0;
}
function selectRow(sender, selectIndex){
    var tds = sender.parentNode.parentNode.getElementsByTagName("td");
    for (var i = 0; i < tds.length; i++){
        var s = tds[i].getElementsByTagName("select")[0];
        if (s && !s.disabled)
            s.selectedIndex = selectIndex;
    }
    sender.selectedIndex = 0;
}
function selectAll(sender, selectIndex, columnIndex){
    if (!columnIndex)
        columnIndex = 0;
    var trs = sender.parentNode.parentNode.parentNode.getElementsByTagName("tr");
    for (var i = 1; i < trs.length; i++){
        var tds = trs[i].getElementsByTagName("td");
        for (ii = columnIndex; ii < tds.length; ii++){
            var s = tds[ii].getElementsByTagName("select")[0];
            if (s && !s.disabled)
                s.selectedIndex = selectIndex;
        }
    }
    sender.selectedIndex = 0;
}

// for autoselect checkboxes
function selectAllCheckboxes(sender, group) {
    var col = sender.form.elements;
    for (var i = 0; i < col.length; i++){
        if (col[i].type == "checkbox" && (group == null || col[i].getAttribute("quickCheckboxSelectGroup") == group) && !col[i].disabled){
            col[i].checked = sender.checked;
        }
    }
}
function checkradio(Sender) {
    if(Sender.checked == false){;
        Sender.checked = false;
    }
    else {
        var col = document.forms("cform").elements(Sender.name);
                for (var i =0; i < col.length; i++)
                {
                     col[i].checked = false;
                }
        Sender.checked = true;
    }
}
function changeTransitionsCheckBox(Sender) { // use on editTransitions
    if (Sender.checked == false) {
        Sender.checked = false;
    } else {
        var col = Sender.parentNode.parentNode.parentNode.getElementsByTagName("input");
        for (var i =0; i < col.length; i++)
            col[i].checked = false;
        Sender.checked = true;
    }
}

// for autoselect checkboxes at edit statuses page
function treesetup(sender) {
    sender.checked = true;
    var parent = sender.getAttribute("parent");
    if(parent != "0")
        treesetup(document.getElementById(parent));
}
function treesetdown(sender){
    var parents = new Array();
    parents[0] = sender.id;
        var col = sender.parentNode.parentNode.getElementsByTagName("input");
        for (var i =0; i < col.length; i++){
                        if (col[i].type == "checkbox") {
                            if(sender.id == "1") {
                                col[i].checked = false;
                                parents[parents.length] = col[i].id;
                                continue;
                            }
                            for (var j = 0; j < parents.length; j ++) {
                                if(col[i].getAttribute("parent") == parents[j]) {
                                    col[i].checked = false;
                                    if(col[i].getAttribute("nochilds") != "true")
                                        parents[parents.length] = col[i].id;
                                    break;
                                }
                            }
                        }
                }
}
function treeset(sender) {
    if (sender.checked)
        treesetup(sender);
    else
        treesetdown(sender);
}

// use on Filter page (filter sort level counter)
function sortorderAction(Sender) {
    var id = Sender.value;
    var ne = false;
    if(id.charAt(0)=='_') {
        id = id.substring(1);
        ne = true;
    }

    if(Sender.checked == true) {
        var element = Sender.parentNode.parentNode;
        var col = element.getElementsByTagName("input");
        var add = true;
        for (var i =0; i < col.length; i++) {
            if(col[i].type =="checkbox" && col[i].value == (ne ? id : "_" + id) && col[i].checked == true) {
                col[i].checked = false;
                add = false;
            }
        }
        if(add)
            levelArray[levelArray.length] = id;
    } else {
        for(var counter = 0; counter < levelArray.length; counter++) {
            if(levelArray[counter] == id) {
                var tmpArray1 = levelArray.slice(0, counter);
                var tmpArray2 = levelArray.slice(counter + 1);
                levelArray = tmpArray1.concat(tmpArray2);
                break;
            }
        }
    }

    for(var counter = 0; counter < levelArray.length; counter++) {
        document.getElementById(levelArray[counter]).innerHTML = counter + 1;
        document.getElementById("h" + levelArray[counter]).value = counter + 1;
    }
    if(Sender.checked == false) {
        document.getElementById(id).innerHTML = "";
        document.getElementById("h" + id).value = 0;
    }
}

// disable/enable controls elements on MailImport page
function mailImportEnableHandler(Sender) {
    var disable = !Sender.checked;
    document.getElementById("keywords").disabled = disable;
    document.getElementById("searchin").disabled = disable;
    document.getElementById("category_select").disabled = disable;
}

// disable/enable controls elements on filterEdit page
function switchByControl(Sender) {
    var element = Sender.parentNode.parentNode;
    if (Sender.checked == true) {
        var col = element.getElementsByTagName("input");
        for (var i =0; i < col.length; i++)
            if(col[i].type!="checkbox" || col[i].name == "sortorder" || col[i].name == "hide") {
                col[i].disabled = false;
                if(col[i].type!="checkbox")
                    col[i].style.backgroundColor="white";
            }
        col = element.getElementsByTagName("select");
        for (var i =0; i < col.length; i++) {
            col[i].disabled = false;
            var opt=col[i].getElementsByTagName("option");
            for (var j =0; j < opt.length; j++) {
                if(opt[j].value=="0")
                    opt[j].selected=true;
                else
                    opt[j].selected=false;
            }
        }
    } else {
        var col = element.getElementsByTagName("input");
        for (var i =0; i < col.length; i++)
            if(col[i].type!="checkbox" || col[i].name == "sortorder" || col[i].name == "hide") {
                col[i].disabled = true;
                if(col[i].type!="checkbox")
                    col[i].style.backgroundColor="#d7d7d7";
            }
        col = element.getElementsByTagName("select");
        for (var i =0; i < col.length; i++) {
            var opt=col[i].getElementsByTagName("option");
            for (var j =0; j < opt.length; j++)
                opt[j].selected=false;
            col[i].disabled = true;
        }
    }
}

// disable/enable controls elements on messageAddForm
function disableControls(Sender) {
    var element = Sender.parentNode.parentNode.parentNode;
    var col = element.getElementsByTagName("input");
    is_new = true;
    for (var i =0; i < col.length; i++)
        if(col[i].type!="radio") {
            col[i].disabled = true;
            col[i].style.backgroundColor="#d7d7d7";
        }
    col = element.getElementsByTagName("select");
    for (var i =0; i < col.length; i++)
        col[i].disabled = true;
    element = Sender.parentNode.parentNode;
    col = element.getElementsByTagName("input");
    for (var i =0; i < col.length; i++)
        if(col[i].type!="radio") {
            col[i].disabled = false;
            col[i].style.backgroundColor="white";
        }
    col = element.getElementsByTagName("select");
    for (var i =0; i < col.length; i++)
        col[i].disabled = false;
}

// write input on CustomEdit page
//mozilla don't like innerHTML!!!
function writeInput(sel, pattern) {
    var udfDefaultValue = document.getElementById("udfDefaultValue");
    var calendarIcon = document.getElementById("calendarIcon");
    var listOfValues = document.getElementById("listOfValues");
    var type;
    for (var i = 0; i < sel.options.length; i++) {
        if (sel.options[i].selected) {
            type = parseInt(sel.options[i].value);
            break;
        }
    }
    if (type == 2) { // Date
        calendarIcon.style.display = "";
        udfDefaultValue.size = 18;
    } else {
        calendarIcon.style.display = "none";
        udfDefaultValue.size = 20;
    }
    if (type == 3) { // List
        udfDefaultValue.style.display = "none";
        udfDefaultValue.disabled = true;
        listOfValues.style.display = "";
        listOfValues.alt=">0";
    } else {
        udfDefaultValue.disabled = false;
        udfDefaultValue.style.display = "";
        listOfValues.style.display = "none";
        listOfValues.alt="";
    }
    switch (type) {
        case 0: // String
            udfDefaultValue.alt = "";
            udfDefaultValue.maxlength = "1800";
            break;
        case 1: // Float
            udfDefaultValue.alt = "float";
            udfDefaultValue.maxlength = "40";
            break;
        case 2: // Date
            udfDefaultValue.alt = "date("+pattern+")";
            udfDefaultValue.maxlength = "40";
            break;
        case 4: // Integer
            udfDefaultValue.alt = "integer";
            udfDefaultValue.maxlength = "40";
            break;
        case 5: // Memo
            udfDefaultValue.alt = "";
            udfDefaultValue.maxlength = "1940";
     }
}

function changeColorSample(el) {
    if (!colorValid(el.value)) {
        disValid(el, "Must be a color value in format \"#dddddd\". ");
    } else {
        el.title = "";
        el.style.backgroundColor = "";
        el.parentNode.getElementsByTagName("span")[0].style.backgroundColor = el.value;
    }
    return true;
}