CREATE INDEX ireport_1 ON gr_report
(
       report_filter
);
%GO%


CREATE INDEX ireport_2 ON gr_report
(
       report_task
);
%GO%


CREATE INDEX ireport_3 ON gr_report
(
       report_owner
);
%GO%


CREATE INDEX ireport_4 ON gr_report
(
       report_priv
);
%GO%


CREATE INDEX ireport_5 ON gr_report
(
       report_rtype
);
%GO%


CREATE INDEX iudfsource_3 ON gr_udfsource
(
       udfsource_workflow
);
%GO%


CREATE INDEX ipriority_1 ON gr_priority
(
       priority_order
);
%GO%


CREATE INDEX ipriority_2 ON gr_priority
(
       priority_workflow
);
%GO%


CREATE INDEX icatrelation_1 ON gr_catrelation
(
       catrelation_category
);
%GO%


CREATE INDEX icatrelation_2 ON gr_catrelation
(
       catrelation_child
);
%GO%


CREATE INDEX icprstatus_1 ON gr_cprstatus
(
       cprstatus_category
);
%GO%


CREATE INDEX icprstatus_2 ON gr_cprstatus
(
       cprstatus_prstatus
);
%GO%


CREATE INDEX inotification_1 ON gr_notification
(
       notification_task                
);
%GO%


CREATE INDEX inotification_2 ON gr_notification
(
       notification_user                
);
%GO%


CREATE INDEX inotification_3 ON gr_notification
(
       notification_filter                
);
%GO%


CREATE INDEX itask_3 ON gr_task
(
       task_priority
);
%GO%

